#pragma once

#include "CoreMinimal.h"
#include "SpectateKillerIndicatorInterface.h"
#include "CoreBaseHudWidget.h"
#include "SpectateKillerIndicatorViewData.h"
#include "UObject/ScriptInterface.h"
#include "CoreSpectateKillerIndicatorWidget.generated.h"

class UCoreSpectateIndicatorInputPrompt;
class UDBDImage;
class UDBDTextBlock;
class ISpectateIndicatorInputPromptViewInterface;

UCLASS(Blueprintable, EditInlineNew)
class DBDUIVIEWSCORE_API UCoreSpectateKillerIndicatorWidget : public UCoreBaseHudWidget, public ISpectateKillerIndicatorInterface
{
	GENERATED_BODY()

protected:
	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UCoreSpectateIndicatorInputPrompt* SpectateIndicatorInputPrompt;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UDBDImage* KillerPowerImg;

	UPROPERTY(BlueprintReadWrite, meta=(BindWidgetOptional))
	UDBDTextBlock* KillerNameTB;

public:
	UFUNCTION(BlueprintCallable)
	void Show();

protected:
	UFUNCTION(BlueprintCallable, BlueprintImplementableEvent)
	void SetVisuals(const FSpectateKillerIndicatorViewData spectateKillerIndicatorViewData);

public:
	UFUNCTION(BlueprintCallable)
	void SetData(const FSpectateKillerIndicatorViewData spectateKillerIndicatorViewData);

	UFUNCTION(BlueprintCallable)
	void Hide();

	UFUNCTION(BlueprintPure)
	TScriptInterface<ISpectateIndicatorInputPromptViewInterface> GetSpectateIndicatorInputPrompt() const;

public:
	UCoreSpectateKillerIndicatorWidget();
};

FORCEINLINE uint32 GetTypeHash(const UCoreSpectateKillerIndicatorWidget) { return 0; }
